# truthiness algo testbed

def friend(i):
    return i > 0

def enemy(i):
    return i < 0

def truth(sub, obj, likes):
    s = '%s %s %s: ' % (sub, ['hates', 'likes'][likes], obj)
    
    same_side = (sub >= 0 and obj >= 0) or (sub <= 0 and obj <= 0)
    #s += 'same side: %s, ' % ['no', 'yes'][same_side]
    
    # usually, just consider the distance between subject and object
    d = sub - obj
    # if two friends or two enemies, diff = combined magnitudes
    if (friend(obj) and friend(sub)) or (enemy(obj) and enemy(sub)):
        d = sub + obj
    s += 'diff %s, ' % d
    
    passion = max(abs(sub), abs(obj))
    s += 'passion %s, ' % passion
    
    t = abs(d)
    # in general, truthful = friends liked, enemies disliked
    if friend(obj):
        # enemy likes friend: nooo
        # TODO: check forgiveness
        if enemy(sub) and likes:
            t *= -1
        if not likes:
            t *= -1
    elif enemy(obj):
        if likes:
            t *= -1
    
    #t /= float(passion)
    s += 'truth %s' % t
    return s

# test suite

aff_range = [1, 8, 0, -1, -8]

for x in aff_range:
    for y in aff_range:
        for z in [True, False]:
            print truth(x, y, z)
